<?php

class SMEAPP_Utils_Filters {
    public static function getCorrectInteger($var)
    {
        return strval(intval($var));
    }
    public static function getCorrectFloat($var) 
    {
        return strval(floatval($var));
    }
    public static function getCorrectIntegerList($list)
    {
        $list = self::splitIntegersList($list);
        
        if (count($list) == 0) {
            return '';
        }
        return implode(',',$list);
    }
    public static function splitIntegersList($list)
    {
        if ($list == '') {
            return array();
        }
        $intlist = array();
        
        $l = explode(',',$list);
        
        foreach($l as $i) {
            $i = self::getCorrectInteger($i);
            
            if ($i > 0) {
                $intlist[] = $i;
            }
        }
        return $intlist;
    }
    public static function removeHTML($val)
    {
        if (empty($val)) {
            return "";
        }
        if (!is_string($val)) {
            return "";
        }
        
        return strip_tags($val);
    }
}
