<?php

/**
 
 * @author    Roman Gelembjuk <roman@gelembjuk.com>
 */
require_once (SITE_DIR . '/include/rfc822_addresses.php');
require_once (SITE_DIR . '/include/mime_parser.php');
require_once (SITE_DIR . "pageclasses/page.php");

class SpecialmessagePage extends Page
{

    function exec($set_headers = false, $code = 404)
    {
        // --- init section ---
        global $gheader, $message, $gcontent_tpl, $gTpl, $gCache, $categories;
        
        if (!is_string($_REQUEST['mess'])) {
            $_REQUEST['mess'] = '...';
        }
        
        if ($_REQUEST['mess'] == 'downloadban') {
            $gheader = SC::T('Download blocked');
            $gcontent_tpl = "download_ban.tpl";
            return true;
        }
        
        $gheader = '...';
        $gcontent_tpl = "specialmessage.tpl";
        
        $mess = '';
        $desc = '';
        $messtype = 'error';
        
        if ($_REQUEST['mess'] == 'filenotfound' && ($_REQUEST['provider_response_status'] == 403) && ! empty($_REQUEST['provider_response_message'])) {
            $_REQUEST['mess'] = SC::T('Forbidden.');
            $_REQUEST['desc'] = $_REQUEST['provider_response_message'];
        }
        
        if ($_REQUEST['mess'] == 'filenotfound') {
            $mess = SC::T('File not found.');
            $desc = SC::T('Try to resync your files or delete this file.');
        }
        if ($_REQUEST['mess'] == 'linkexpired') {
            if ($_REQUEST['messorig'] != '') {
                $mess = $_REQUEST['messorig'];
                $desc = '';
            } else {
                $mess = SC::T('File not found.');
                $desc = SC::T('The file link has either expired or has been removed.');
            }
        }
        if ($_REQUEST['mess'] == 'linkdeleted') {
            $mess = SC::T('File not found.');
            $desc = SC::T('The file link has been removed.');
        }
        if ($_REQUEST['mess'] == 'linkforbidden') {
            $mess = SC::T('Forbidden.');
            $desc = SC::T('File Access is forbidden.');
        }
        if ($_REQUEST['mess'] == 'filenotfoundfortool') {
            $mess = SC::T('File not found.');
            $desc = SC::T('It is not possible to load the file. Try to download the file.');
        }
        if ($_REQUEST['mess'] == 'filesaved') {
            $mess = SC::T('The file was successfully saved.');
            $desc = '<a href="javascript:window.close()">' . SC::T('Close') . '</a>';
            $messtype = 'success';
        }
        if ($_REQUEST['mess'] == 'filedescriptionsaved') {
            $mess = SC::T('The file description was successfully saved.');
            $desc = '<a href="javascript:window.close()">' . SC::T('Close') . '</a>';
            $messtype = 'success';
        }
        if ($_REQUEST['mess'] == 'paypalcancel') {
            $mess = SC::T('Payment was canceled.');
            $desc = SC::T('Upgrade is not completed.');
        }
        if ($_REQUEST['mess'] == 'cannotrestorefile') {
            $mess = SC::T("Can't restore file.");
            $desc = SC::T('File backup is not avaliable.');
        }
        if ($_REQUEST['mess'] == 'paypalcancel') {
            $mess = SC::T('Payment not processed');
            $desc = SC::T('You can try to register one of free packages.');
        }
        if ($_REQUEST['mess'] == 'bandwidthlimitreached1') {
            $mess = SC::T('Bandwidth limit reached');
            $desc = SC::T("You can't download this file now because you reached you bandwidth limit.");
        }
        if ($_REQUEST['mess'] == 'bandwidthlimitreached2') {
            $mess = SC::T('Bandwidth limit reached');
            $desc = SC::T("You can't download this file now because file's owner reached his bandwidth limit for this month.");
        }
        if ($_REQUEST['mess'] == 'fileislocked') {
            $mess = SC::T('This file is locked');
            $desc = SC::T("You can't download this file because it is locked.");
        }
        if ($_REQUEST['mess'] == 'archdwn') {
            $mess = SC::T('Restore in process');
            $desc = SC::T('The File you requested must first be restored. Once the file is restored you will be alerted via email.');
        }
        if ($_REQUEST['mess'] == 'unarchived') {
            $mess = SC::T('This link is no longer available');
            $desc = SC::T('The file you have requested is archived, please select download/restore to restore the file.');
        }
        if ($_REQUEST['mess'] == 'toomanydownloadsofthisfile') {
            $mess = SC::T('Another copy of downloading is in progress');
            $desc = SC::T('You already are downloading this file');
        }
        if (isset($_REQUEST['provider_response_status']) && intval($_REQUEST['provider_response_status']) == 460) {
            $mess = SC::T('Restricted');
            $desc = SC::T('Restricted Content This file is no longer available. For additional information contact Provider Support.');
        }
        if (($mess == '') && ($_REQUEST['mess'] == '')) {
            $gTpl->assign("justemptypage", '1');
            return '';
        }
        if ($mess == '') {
            $mess = $_REQUEST['mess'];
        }
        if ($desc == '') {
            $desc = $_REQUEST['desc'];
        }
        
        if ($set_headers) {
            if ($code == 404) {
                header("HTTP/1.1 404 Not Found");
            } else {
                header("HTTP/1.1 408 Forbidden");
            }
            header("X-SME-DOWNLOAD-ERROR: " . base64_encode(trim($mess . ' ' . $desc)));
        }
        
        $mess = SMEAPP_Utils_Filters::removeHTML($mess);
        
        $gheader = $mess;
        $gTpl->assign("justemptypage", '0');
        $gTpl->assign("mess", $mess);
        $gTpl->assign("description", $desc);
        $gTpl->assign("messagetype", $messtype);
        
        return TRUE;
    }
}

